{$u+}
{  MPUVER.PAS  by Les Penner }
{  Finds MPU-401 ROM version number}
{  Compile with Turbo Pascal}
{  Uses routines written by Carter Scholz in Keyboard Magazine, Aug, 1986}
type
   str1 = string[1];
   str2 = string[2];

var
   j, MidiData: byte;
   ch         : char;

const
   dataport=$330;                   { These are port addresses for the }
   statport=$331;                   { IBM version of the MPU-401.      }
   drs=$80;                         { They must be changed for other   }
   drr=$40;                         { machines.                        }
   ack=$fe;
   h       : array [0..15] of char = '0123456789ABCDEF';
   letter  : array [0..10] of char = ' ABCDEFGHIJ';
procedure PutData (MidiData:byte);  { Puts one byte to MPU.            }
   begin
      j := 0;
      repeat                        { Loop until Data Ready to Send    }
         j := port [statport];      { has correct value; then send     }
      until (j and drr)=0;          { MIDI data to DataPort.           }
      port [dataport] := MidiData;
    end;

procedure GetData (var MidiData:byte); { Gets one byte from MPU. }
    var
      j:byte;
    begin
      j := 0;
      repeat                        { Loop until Data Ready to Receive }
        j := port [statport];       { has correct value; then get      }
      until (j and drs)=0;          { MIDI data from DataPort.         }
      MidiData := port [dataport];
    end;

procedure PutCmd (cmd:byte);        { Sends command to MPU. }
    begin
      j := 0;
      repeat                        { Loop until Data Ready to Receive }
        j := port [statport];       { has correct value; then send     }
      until (j and drr)=0;          { command to MPU.                  }
      port [statport] := cmd;
      repeat                        { Wait in loop until MPU sends byte }
        GetData(j);                 { to acknowledge receipt of command. }
      until j=ack;
    end;

function LoHex(b:byte):str2;
    begin
      LoHex := h [b and 15];
    end;

function HiHex(b:byte):str2;
    begin
      HiHex := h [b shr 4];
    end;


{ **** Main Program **** }

begin
     clrscr;
     gotoxy(15,8);
     write('The ROM version in this MPU-401 is: ');
     putcmd($ac);
     getdata(mididata);
     write(hihex(mididata),'.',lohex(mididata));
     putcmd($ad);
     getdata(mididata);
     write(letter[mididata]);

end.

